Subject: RE: [Sip] Question on offer-answer during establishment

From: "Christer Holmberg (JO/LMF)" <[email-masked]>
Date: Wed, 29 Sep 2004 07:03:15 +0200

Hi,

>>Please also note, that you are only allowed to send SDP 
>>(offer or answer) in the FIRST PRACK, so even if you would 
>>send new offers in provisional responses you would still have 
>>to use a non-PRACK mechanism to send the answers.
>> 
>>Sending SDPs in PRACK then causes other problems, ie how 
>>you would reject those, but that's another issue...
> 
>Christer,
> 
>I have to quibble with the above.
> 
>If the INVITE is offerless, then an offer must be present in 
>the first reliable response. If that is a reliable 1xx, then the 1xx must be 
>answered with a PRACK, and that prack must contain the answer. So in 
>that case the answer would be in the first PRACK.

Correct.

>I believe that is the *only* case in which an answer can be 
>in a PRACK, and that there are *no* cases where an offer can be in a prack.

I would be very happy if that was true :)

However, chapter 5 in RFC 3262 says:

"If the UAC receives a reliable provisional response with an answer, it MAY generate an
additional offer in the PRACK."

Now, I have to admit I did not find the text saying that we're only allowed to use the first PRACK to send a new offer, but my understanding is that that is the case, and one of the reasons for that was to "save" a SIP transaction in pre-condition scenarios (instead of sending the first updated offer in an UPDATE you can use the PRACK). But, correct me if I'm wrong.

At the previous SIPit we had some discussions about the usage of PRACK for offer/answer. The problem, as said before, is that there is currently no standard way to reject an offer received in a PRACK, because a UAS MUST answer with 200 OK, if the PRACK otherwise is ok, matches a reliabel provisional response etc. It has even been suggested that it should be forbidden to send SDPs (at least new offers) in PRACKs, but that would of course have impacts on existing nodes - depending on how many nodes currently support it in the first place, of course.

Regards,

Christer Holmberg
Ericsson Finland

> 	Paul

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: Michael Zhou <[email-masked]>
Date: Wed, 29 Sep 2004 09:59:44 -0400

>At the previous SIPit we had some discussions about the usage of PRACK for offer/answer. The problem, as said before, is that there is currently no standard way to reject an offer received in a PRAC…
It's not mentioned in RFC 3262 how to reject an offer, but 488 (Not 
Acceptable Here) might be a natural choice according to Section 13.3.1.3 
of RFC 3261, quoted below. In practice, 4xx-6xx respons to PRACK (which 
contains offer) may also be considered rejection of offer.

"

   A UAS rejecting an offer contained in an INVITE SHOULD return a 488
   (Not Acceptable Here) response.  Such a response SHOULD include a
   Warning header field value explaining why the offer was rejected.

"